/*
    This file is part of the Okteta Kakao module, part of the KDE project.

    Copyright 2007 Friedrich W. H. Kossebau <kossebau@kde.org>

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Lesser General Public
    License as published by the Free Software Foundation; either
    version 2.1 of the License, or (at your option) version 3, or any
    later version accepted by the membership of KDE e.V. (or its
    successor approved by the membership of KDE e.V.), which shall
    act as a proxy defined in Section 6 of version 3 of the license.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public
    License along with this library. If not, see <http://www.gnu.org/licenses/>.
*/

#ifndef KBYTEARRAYRAWFILESYNCHRONIZER_H
#define KBYTEARRAYRAWFILESYNCHRONIZER_H


// Kakao core
#include <kabstractdocumentfilesystemsynchronizer.h>

class KByteArrayDocument;

class KByteArrayRawFileSynchronizer : public KAbstractDocumentFileSystemSynchronizer
{
    Q_OBJECT

  public:
    KByteArrayRawFileSynchronizer( KAbstractDocument *document, const KUrl &url,
                                   KAbstractDocumentSynchronizer::ConnectOption option );
    explicit KByteArrayRawFileSynchronizer( const KUrl &originUrl );

  public: // KAbstractDocumentSynchronizer API
    virtual KAbstractDocument *document() const;

  protected: // KAbstractDocumentFileSystemSynchronizer API
    virtual KAbstractDocument *loadFromFile( const QString &workFilePath );
    virtual bool reloadFromFile( const QString &workFilePath );
    virtual bool writeToFile( const QString &workFilePath );
    virtual bool syncWithFile( const QString &workFilePath,
                               KAbstractDocumentSynchronizer::ConnectOption option );

  protected Q_SLOTS:
    void onUrlChange( const KUrl &url );

  protected:
    KByteArrayDocument *mDocument;
};

#endif
